MappingSqlQuery (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.jdbc.object

## Class MappingSqlQuery<T>

- java.lang.Object
- - org.springframework.jdbc.object.RdbmsOperation
  - - org.springframework.jdbc.object.SqlOperation
    - - org.springframework.jdbc.object.SqlQuery<T>
      - - org.springframework.jdbc.object.MappingSqlQueryWithParameters<T>
        - - org.springframework.jdbc.object.MappingSqlQuery<T>

- All Implemented Interfaces:
    InitializingBean
  Direct Known Subclasses:
    SqlFunction

      public abstract class MappingSqlQuery<T>
      extends MappingSqlQueryWithParameters<T>

  Reusable query in which concrete subclasses must implement the abstract mapRow(ResultSet, int) method to convert each row of the JDBC ResultSet into an object.

  Simplifies MappingSqlQueryWithParameters API by dropping parameters and context. Most subclasses won't care about parameters. If you don't use contextual information, subclass this instead of MappingSqlQueryWithParameters.

  Author:
    Rod Johnson, Thomas Risberg, Jean-Pierre Pawlak
  See Also:
    `MappingSqlQueryWithParameters`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.springframework.jdbc.object.MappingSqlQueryWithParameters

      `MappingSqlQueryWithParameters.RowMapperImpl`

  - ### Field Summary

    - ### Fields inherited from class org.springframework.jdbc.object.RdbmsOperation

      `logger`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MappingSqlQuery()` Constructor that allows use as a JavaBean.
    `MappingSqlQuery(DataSource ds, String sql)` Convenient constructor with DataSource and SQL string.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected abstract T` | `mapRow(ResultSet rs, int rowNum)` Subclasses must implement this method to convert each row of the ResultSet into an object of the result type.
    `protected T` | `mapRow(ResultSet rs, int rowNum, Object[] parameters, Map context)` This method is implemented to invoke the simpler mapRow template method, ignoring parameters.

    - ### Methods inherited from class org.springframework.jdbc.object.MappingSqlQueryWithParameters

      `newRowMapper`

    - ### Methods inherited from class org.springframework.jdbc.object.SqlQuery

      `execute, execute, execute, execute, execute, execute, execute, execute, execute, execute, execute, execute, executeByNamedParam, executeByNamedParam, findObject, findObject, findObject, findObject, findObject, findObject, findObject, findObject, findObject, findObject, findObjectByNamedParam, findObjectByNamedParam, getRowsExpected, setRowsExpected`

    - ### Methods inherited from class org.springframework.jdbc.object.SqlOperation

      `compileInternal, getParsedSql, newPreparedStatementCreator, newPreparedStatementCreator, newPreparedStatementSetter, onCompileInternal`

    - ### Methods inherited from class org.springframework.jdbc.object.RdbmsOperation

      `afterPropertiesSet, allowsUnusedParameters, checkCompiled, compile, declareParameter, getDeclaredParameters, getGeneratedKeysColumnNames, getJdbcTemplate, getResultSetType, getSql, isCompiled, isReturnGeneratedKeys, isUpdatableResults, setDataSource, setFetchSize, setGeneratedKeysColumnNames, setJdbcTemplate, setMaxRows, setParameters, setQueryTimeout, setResultSetType, setReturnGeneratedKeys, setSql, setTypes, setUpdatableResults, supportsLobParameters, validateNamedParameters, validateParameters`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### MappingSqlQuery

          public MappingSqlQuery()

      Constructor that allows use as a JavaBean.

    - #### MappingSqlQuery

          public MappingSqlQuery(DataSource ds,
                         String sql)

      Convenient constructor with DataSource and SQL string.
      Parameters:
        `ds` - DataSource to use to obtain connections
        `sql` - SQL to run

  - ### Method Detail

    - #### mapRow

          protected final T mapRow(ResultSet rs,
                 int rowNum,
                 Object[] parameters,
                 Map context)
                            throws SQLException

      This method is implemented to invoke the simpler mapRow template method, ignoring parameters.
      Specified by:
        `mapRow` in class `MappingSqlQueryWithParameters<T>`
      Parameters:
        `rs` - ResultSet we're working through
        `rowNum` - row number (from 0) we're up to
        `parameters` - to the query (passed to the execute() method). Subclasses are rarely interested in these. It can be `null` if there are no parameters.
        `context` - passed to the execute() method. It can be `null` if no contextual information is need.
      Returns:
        an object of the result type
      Throws:
        `SQLException` - if there's an error extracting data. Subclasses can simply not catch SQLExceptions, relying on the framework to clean up.
      See Also:
        `mapRow(ResultSet, int)`

    - #### mapRow

          protected abstract T mapRow(ResultSet rs,
                 int rowNum)
                               throws SQLException

      Subclasses must implement this method to convert each row of the ResultSet into an object of the result type.

      Subclasses of this class, as opposed to direct subclasses of MappingSqlQueryWithParameters, don't need to concern themselves with the parameters to the execute method of the query object.

      Parameters:
        `rs` - ResultSet we're working through
        `rowNum` - row number (from 0) we're up to
      Returns:
        an object of the result type
      Throws:
        `SQLException` - if there's an error extracting data. Subclasses can simply not catch SQLExceptions, relying on the framework to clean up.